/*
  ChipKIT HelvePic32 BB SideKick Demos
  RGB LED

  This sketch fades the RGB components of an RGB LED (4 pins)
  This SOftPWM can be used on any pin of the HelvePIC32 BB SideKick

  This example code is in the public domain.
  Based on AnalogWriteMega example code
  Based on code from Brian Schmalz http://www.schmalzhaus.com
*/

#include <SoftPWMServo.h>

const int pinR = 0;
const int pinG = 1;
const int pinB = 2;
int brightR = 0;
int brightG = 170;
int brightB = 170;
int cntR = 1;
int cntG = 1;
int cntB = -1;


void setup() {
	// The SoftPWMServo library sets any used pins to be outputs, so that's not needed here
	// light up every color to start
	SoftPWMServoPWMWrite(pinR, 0);
	SoftPWMServoPWMWrite(pinG, 0);
	SoftPWMServoPWMWrite(pinB, 0);

	for(brightR = 0; brightR<256; brightR++) {
		SoftPWMServoPWMWrite(pinR, brightR);
		delay(10);
	}

	delay(1000);
	SoftPWMServoPWMWrite(pinR, 0);

	for(brightG = 0; brightG<256; brightG++) {
		SoftPWMServoPWMWrite(pinG, brightG);
		delay(10);
	}

	delay(1000);
	SoftPWMServoPWMWrite(pinG, 0);

	for(brightB = 0; brightB<256; brightB++) {
		SoftPWMServoPWMWrite(pinB, brightB);
		delay(10);
	}

	SoftPWMServoPWMWrite(pinB, 0);
	delay(1000);
}

void loop() {
	// fade the LED on thisPin from off to brightest:

	// fade out red, fade in green
	for(int bright=0; bright<256; bright++) {
		SoftPWMServoPWMWrite(pinR, 255-bright);
		SoftPWMServoPWMWrite(pinG, bright);
		delay(10);
	}

	// fade out green, fade in blue
	for(int bright=0; bright<256; bright++) {
		SoftPWMServoPWMWrite(pinG, 255-bright);
		SoftPWMServoPWMWrite(pinB, bright);
		delay(10);
	}

	// fade out blue, fade in red
	for(int bright=0; bright<256; bright++) {
		SoftPWMServoPWMWrite(pinB, 255-bright);
		SoftPWMServoPWMWrite(pinR, bright);
		delay(10);
	}
}
